Merge remote-tracking branch 'cbab-github/tests-cleanup' into cbab
[lttng-tools.git] / tests / regression / tools / streaming / test_high_throughput_limits
CommitLineData
17fe0490
CB
1#!/bin/bash
2#
3# Copyright (C) - 2012 Christian Babeux <christian.babeux@efficios.com>
4# David Goulet <dgoulet@efficios.com>
5#
6# This library is free software; you can redistribute it and/or modify it under
7# the terms of the GNU Lesser General Public License as published by the Free
8# Software Foundation; version 2.1 of the License.
9#
10# This library is distributed in the hope that it will be useful, but WITHOUT
11# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
12# FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
13# details.
14#
15# You should have received a copy of the GNU Lesser General Public License
16# along with this library; if not, write to the Free Software Foundation, Inc.,
17# 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
b2068598
DG
18
19TEST_DESC="Streaming - High throughput with bandwidth limits"
17fe0490
CB
20
21CURDIR=$(dirname $0)/
9ac429ef 22TESTDIR=$CURDIR/../../..
17fe0490
CB
23NR_APP_ITER=10
24NR_ITER=1000000
25BIN_NAME="gen-ust-events"
26SESSION_NAME="high-throughput"
27EVENT_NAME="tp:tptest"
28SESSIOND_CTRL_PORT=5342
29SESSIOND_DATA_PORT=5343
30DEFAULT_IF="lo"
31
32TRACE_PATH=$(mktemp -d)
33
d346ccad
CB
34NUM_TESTS=112
35
9ac429ef 36source $TESTDIR/utils/utils.sh
17fe0490
CB
37
38print_test_banner "$TEST_DESC"
39
40if [ ! -x "$CURDIR/$BIN_NAME" ]; then
d346ccad 41 BAIL_OUT "No UST nevents binary detected."
17fe0490
CB
42fi
43
44function set_bw_limit
45{
46 limit=$1
ffaed7f7
JD
47 ctrlportlimit=$(($limit/10))
48 # failsafe to have at least 1kbit/s for control (in the case where $1 < 10)
49 [ $ctrlportlimit = 0 ] && ctrlportlimit=1
50 # if $1 < 10, we might bust the limit set here, but the
51 # parent qdisc (1:) will always limit us to the right max value
52 dataportlimit=$((9*${ctrlportlimit}))
53
d346ccad 54
17fe0490 55 tc qdisc add dev $DEFAULT_IF root handle 1: htb default 15 >/dev/null 2>&1
17fe0490 56
ffaed7f7
JD
57 # the total bandwidth is the limit set by the user
58 tc class add dev $DEFAULT_IF parent 1: classid 1:1 htb rate ${limit}kbit ceil ${limit}kbit >/dev/null 2>&1
59 # 1/10 of the bandwidth guaranteed and traffic prioritized for the control port
60 tc class add dev $DEFAULT_IF parent 1:1 classid 1:10 htb rate ${ctrlportlimit}kbit ceil ${limit}kbit prio 1 >/dev/null 2>&1
61 # 9/10 of the bandwidth guaranteed and can borrow up to the total bandwidth (if unused)
62 tc class add dev $DEFAULT_IF parent 1:1 classid 1:11 htb rate ${dataportlimit}kbit ceil ${limit}kbit prio 2 >/dev/null 2>&1
17fe0490 63
ffaed7f7
JD
64 # filter to assign control traffic to the 1:10 class
65 tc filter add dev $DEFAULT_IF parent 1: protocol ip u32 match ip dport $SESSIOND_CTRL_PORT 0xffff flowid 1:10 >/dev/null 2>&1
66 # filter to assign data traffic to the 1:11 class
67 tc filter add dev $DEFAULT_IF parent 1: protocol ip u32 match ip dport $SESSIOND_DATA_PORT 0xffff flowid 1:11 >/dev/null 2>&1
d346ccad
CB
68
69 ok $? "Set bandwidth limits to ${limit}kbits, ${ctrlportlimit} for control and ${dataportlimit} for data"
17fe0490
CB
70}
71
72function reset_bw_limit
73{
17fe0490 74 tc qdisc del dev $DEFAULT_IF root >/dev/null 2>&1
d346ccad 75 ok $? "Reset bandwith limits"
17fe0490
CB
76}
77
78function create_lttng_session_with_uri
79{
80 sess_name=$1
81 uri=$2
82 # Create session with custom URI
83 $TESTDIR/../src/bin/lttng/$LTTNG_BIN create -U $uri $sess_name >/dev/null 2>&1
d346ccad 84 ok $? "Create session with uri $uri"
17fe0490
CB
85}
86
17fe0490
CB
87function run_apps
88{
89 for i in `seq 1 $NR_APP_ITER`; do
b2068598
DG
90 # With bandwidth limitation, unfortunately, application easily timeout
91 # due to very slow communication between the consumer and relayd making
92 # the status reply from the consumer quite slow thus delaying the
93 # registration done message.
bfdaf0fd 94 LTTNG_UST_REGISTER_TIMEOUT=-1 ./$CURDIR/$BIN_NAME $NR_ITER & >/dev/null 2>&1
17fe0490
CB
95 done
96}
97
98function wait_apps
99{
17fe0490 100 while [ -n "$(pidof $BIN_NAME)" ]; do
17fe0490
CB
101 sleep 1
102 done
d346ccad 103 pass "Wait for applications to end"
17fe0490
CB
104}
105
106function test_high_throughput
107{
108 NETWORK_URI="net://localhost"
109 create_lttng_session_with_uri $SESSION_NAME $NETWORK_URI
17fe0490
CB
110 enable_ust_lttng_event $SESSION_NAME $EVENT_NAME
111 start_lttng_tracing $SESSION_NAME
112 run_apps
113 wait_apps
17fe0490
CB
114 stop_lttng_tracing $SESSION_NAME
115 destroy_lttng_session $SESSION_NAME
116 validate_event_count
117}
118
119function validate_event_count
120{
121
122 TEMP_FILE=$(mktemp)
123 TEMP_FILE_2=$(mktemp)
124
125 traced=$(babeltrace $TRACE_PATH 2>/dev/null | wc -l)
126 babeltrace $TRACE_PATH >/dev/null 2>$TEMP_FILE_2
127
128 cat $TEMP_FILE_2 | cut -f4 -d " " >$TEMP_FILE
129
130 dropped=0
131 while read line;
132 do
133 let dropped=$dropped+$line
134 done < $TEMP_FILE
135
136 let total=$dropped+$traced
137 let wanted=$NR_APP_ITER*$NR_ITER
138
17fe0490 139 if [ $wanted -ne $total ]; then
d346ccad
CB
140 fail "Validate trace event count"
141 diag "Expected $wanted. Dropped $dropped. Recorded $traced. Total $total... "
17fe0490
CB
142 return 1
143 else
d346ccad
CB
144 pass "Validate trace event count"
145 diag "Expected $wanted. Dropped $dropped. Recorded $traced. Total $total... "
b2068598 146
b2068598
DG
147 rm -rf $TRACE_PATH
148 rm $TEMP_FILE $TEMP_FILE_2
149
17fe0490
CB
150 return 0
151 fi
152}
153
154function interrupt_cleanup()
155{
d346ccad 156 diag "*** Exiting ***"
17fe0490
CB
157 stop_lttng_relayd
158 stop_lttng_sessiond
159 reset_bw_limit
160 exit 1
161}
162
d346ccad 163plan_tests $NUM_TESTS
17fe0490 164
d346ccad
CB
165if [ "$(id -u)" == "0" ]; then
166 isroot=1
167else
168 isroot=0
169fi
17fe0490 170
d346ccad
CB
171skip $isroot "Root access is needed to set bandwith limits. Skipping all tests." $NUM_TESTS ||
172{
17fe0490 173
d346ccad
CB
174 # Catch sigint and try to cleanup limits
175 trap interrupt_cleanup SIGINT
176
177 BW_LIMITS=(3200 1600 800 400 200 100 50 25)
178 for BW in ${BW_LIMITS[@]};
179 do
180 diag "Test high-throughput with bandwidth limit set to ${BW}kbits"
181 set_bw_limit $BW
182
183 start_lttng_sessiond
184 start_lttng_relayd "-o $TRACE_PATH"
185 test_high_throughput
186 result=$?
187 stop_lttng_relayd
188 stop_lttng_sessiond
189 reset_bw_limit
190 done
191}
This page took 0.032251 seconds and 4 git commands to generate.